# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

class account_invoice_line(osv.osv):
     _inherit = "account.invoice.line"
     _columns = {
              'product_second_uom_qty': fields.float('Quantity (Second UoM)', digits=(16, 2)),
              'product_second_uom': fields.many2one('product.uom', 'Product Second UoM'),
              'related_use_second_uom': fields.related('product_id', 'use_second_uom', type='boolean', string='Use Second UOM'),
              }
     _defaults = {
                'product_second_uom_qty': lambda *a: 1
                }
     
     
     def product_id_change(self, cr, uid, ids, product, uom, qty=0, name='', type='out_invoice', partner_id=False, fposition_id=False, price_unit=False, address_invoice_id=False, context=None):
         
        result = super(account_invoice_line, self).product_id_change(cr, uid, ids, product, uom, qty, name, type, partner_id, fposition_id, price_unit, address_invoice_id, context)
         
        if product:
           product_obj = self.pool.get('product.product').browse(cr, uid, product)
           if product_obj.use_second_uom:
                result['value'].update({'product_second_uom': product_obj.second_uom_id.id, 'related_use_second_uom': product_obj.use_second_uom})
           else:
                result['value'].update({'product_second_uom_qty': False, 'product_second_uom': False, 'related_use_second_uom': False})
        else:
            result['value'].update({'product_second_uom_qty': False, 'product_second_uom': False, 'related_use_second_uom': False})
            
        return result
         
account_invoice_line()