# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class product_product(osv.osv):
    _inherit = "product.product"
    
    def get_second_product_available(self,cr,uid,ids,context=None):
        if not context:
            context = {}
        states=context.get('states',[])
        what=context.get('what',())
        if not ids:
            ids = self.search(cr, uid, [])
        res = {}.fromkeys(ids, 0.0)
        if not ids:
            return res
    
        if context.get('shop', False):
            cr.execute('select warehouse_id from sale_shop where id=%s', (int(context['shop']),))
            res2 = cr.fetchone()
            if res2:
                context['warehouse'] = res2[0]
    
        if context.get('warehouse', False):
            cr.execute('select lot_stock_id from stock_warehouse where id=%s', (int(context['warehouse']),))
            res2 = cr.fetchone()
            if res2:
                context['location'] = res2[0]
    
        if context.get('location', False):
            if type(context['location']) == type(1):
                location_ids = [context['location']]
            else:
                location_ids = context['location']
        else:
            location_ids = []
            wids = self.pool.get('stock.warehouse').search(cr, uid, [], context=context)
            for w in self.pool.get('stock.warehouse').browse(cr, uid, wids, context=context):
                location_ids.append(w.lot_stock_id.id)
    
        # build the list of ids of children of the location given by id
        if context.get('compute_child',True):
            child_location_ids = self.pool.get('stock.location').search(cr, uid, [('location_id', 'child_of', location_ids)])
            location_ids= len(child_location_ids) and child_location_ids or location_ids
        else:
            location_ids= location_ids
    
        states_str = ','.join(map(lambda s: "'%s'" % s, states))
    
        uoms_o = {}
        product2uom = {}
        for product in self.browse(cr, uid, ids, context=context):
            product2uom[product.id] = product.uom_id.id
            uoms_o[product.uom_id.id] = product.uom_id
    
        prod_ids_str = ','.join(map(str, ids))
        location_ids_str = ','.join(map(str, location_ids))
        results = []
        results2 = []
    
        from_date=context.get('from_date',False)
        to_date=context.get('to_date',False)
        date_str=False
        if from_date and to_date:
            date_str="date_planned>='%s' and date_planned<='%s'"%(from_date,to_date)
        elif from_date:
            date_str="date_planned>='%s'"%(from_date)
        elif to_date:
            date_str="date_planned<='%s'"%(to_date)
    
        if 'in' in what:
            # all moves from a location out of the set to a location in the set
            cr.execute(
                'select sum(product_second_uom_qty), product_id, product_uom '\
                'from stock_move '\
                'where location_id not in ('+location_ids_str+') '\
                'and location_dest_id in ('+location_ids_str+') '\
                'and product_id in ('+prod_ids_str+') '\
                'and state in ('+states_str+') '+ (date_str and 'and '+date_str+' ' or '') +''\
                'group by product_id,product_uom'
            )
            results = cr.fetchall()
        if 'out' in what:
            # all moves from a location in the set to a location out of the set
            cr.execute(
                'select sum(product_second_uom_qty), product_id, product_uom '\
                'from stock_move '\
                'where location_id in ('+location_ids_str+') '\
                'and location_dest_id not in ('+location_ids_str+') '\
                'and product_id in ('+prod_ids_str+') '\
                'and state in ('+states_str+') '+ (date_str and 'and '+date_str+' ' or '') + ''\
                'group by product_id,product_uom'
            )
            results2 = cr.fetchall()
        uom_obj = self.pool.get('product.uom')
        uoms = map(lambda x: x[2], results) + map(lambda x: x[2], results2)
        if context.get('uom', False):
            uoms += [context['uom']]
    
        uoms = filter(lambda x: x not in uoms_o.keys(), uoms)
        if uoms:
            uoms = uom_obj.browse(cr, uid, list(set(uoms)), context=context)
        for o in uoms:
            uoms_o[o.id] = o
        for amount, prod_id, prod_uom in results:
            if self.browse(cr, uid, prod_id, context=context).use_second_uom:
                if not (type(amount) in [int, float]):
                    amount=0
                amount = uom_obj._compute_qty_obj(cr, uid, uoms_o[prod_uom], amount,
                        uoms_o[context.get('uom', False) or product2uom[prod_id]])
            else:
                amount = 0
            res[prod_id] += amount
        for amount, prod_id, prod_uom in results2:
            if self.browse(cr, uid, prod_id, context=context).use_second_uom:
                if not (type(amount) in [int, float]):
                    amount=0
                amount = uom_obj._compute_qty_obj(cr, uid, uoms_o[prod_uom], amount,
                        uoms_o[context.get('uom', False) or product2uom[prod_id]])
            else:
                amount = 0 
            res[prod_id] -= amount            
        return res

    def _second_product_available(self, cr, uid, ids, field_names=None, arg=False, context={}):
        if not field_names:
            field_names=[]
        res = {}
        for id in ids:
            res[id] = {}.fromkeys(field_names, False)
        
        for f in field_names:
            c = context.copy()
            if f=='second_qty_available':
                c.update({ 'states':('done',), 'what':('in', 'out') })
            if f=='second_virtual_available':
                c.update({ 'states':('confirmed','waiting','assigned','done'), 'what':('in', 'out') })
            if f=='second_incoming_qty':
                c.update({ 'states':('confirmed','waiting','assigned'), 'what':('in',) })
            if f=='second_outgoing_qty':
                c.update({ 'states':('confirmed','waiting','assigned'), 'what':('out',) })
            stock=self.get_second_product_available(cr,uid,ids,context=c)
            for id in ids:
                product = self.browse(cr, uid, id, context)
                if product.use_second_uom:
                    res[id][f] = stock.get(id, False)
        return res

    def onchange_use_second_uom(self, cr, uid, ids, use_second_uom):
	v = {}
	if not use_second_uom:
	    return {'value': {'second_uom_id': ''}}
	return {'value': v}
    
    _columns = {
        'second_uom_id': fields.many2one('product.uom', 'Second UoM', help="Default Second Unit of Measure used for Sales, Purchase, Invoices and all stock operation."),
        'second_qty_available': fields.function(_second_product_available, method=True, type='float', string='Second Real Stock', help="Current quantities of products in selected locations or all internal if none have been selected.", multi='second_qty_available'),
        'second_virtual_available': fields.function(_second_product_available, method=True, type='float', string='Second Virtual Stock', help="Futur stock for this product according to the selected location or all internal if none have been selected. Computed as: Real Stock - Outgoing + Incoming.", multi='second_qty_available'),
        'second_incoming_qty': fields.function(_second_product_available, method=True, type='float', string='Incoming', help="Quantities of products that are planned to arrive in selected locations or all internal if none have been selected.", multi='qty_available'),
        'second_outgoing_qty': fields.function(_second_product_available, method=True, type='float', string='Outgoing', help="Quantities of products that are planned to leave in selected locations or all internal if none have been selected.", multi='qty_available'),
	'use_second_uom': fields.boolean('Use Second UOM?'),
    }
product_product()