# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

class purchase_order(osv.osv):
    _inherit = "purchase.order"

    def action_picking_create(self,cr, uid, ids, *args):
        
        result = super(purchase_order, self).action_picking_create(cr, uid, ids, *args)
         
        if result:
            for order in self.browse(cr, uid, ids, context={}):
                for line in order.order_line:
                    for move in line.move_ids:
                        self.pool.get('stock.move').write(cr, uid, move.id, {'product_second_uom_qty': line.product_second_uom_qty, 'product_second_uom': line.product_second_uom.id})
                        
        return result
    
    def inv_line_create(self, cr, uid, a, ol):
     
         result = super(purchase_order, self).inv_line_create(cr, uid, a, ol)
         result[-1].update({'product_second_uom_qty': ol.product_second_uom_qty, 'product_second_uom': ol.product_second_uom.id}) 
         return result
            
purchase_order()

class purchase_order_line(osv.osv):
     _inherit = "purchase.order.line"
     _columns = {
              'product_second_uom_qty': fields.float('Quantity (Second UoM)', digits=(16, 2)),
              'product_second_uom': fields.many2one('product.uom', 'Product Second UoM'),
              'related_use_second_uom': fields.related('product_id', 'use_second_uom', type='boolean', string='Use Second UOM'),
              }
     
     _defaults = {
                'product_second_uom_qty': lambda *a: 1
                }
     
     def product_id_change(self, cr, uid, ids, pricelist, product, qty, uom,
            partner_id, date_order=False, fiscal_position=False):
            result = super(purchase_order_line, self).product_id_change( cr, uid, ids, pricelist, product, qty, uom, partner_id, date_order, fiscal_position)
            if product:
                product_obj = self.pool.get('product.product').browse(cr, uid, product)
                if product_obj.use_second_uom:
                    result['value'].update({'product_second_uom': product_obj.second_uom_id.id, 'related_use_second_uom': product_obj.use_second_uom})
                else:
                    result['value'].update({'product_second_uom_qty': False, 'product_second_uom': False, 'related_use_second_uom': False})
            else:
                result['value'].update({'product_second_uom_qty': False, 'product_second_uom': False, 'related_use_second_uom': False})
            
            return result
     
purchase_order_line()