# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

class sale_order(osv.osv):
    _inherit = "sale.order"
    
    def action_ship_create(self, cr, uid, ids, *args):
        result = super(sale_order, self).action_ship_create(cr, uid, ids, *args)
        
        if result:
            for order in self.browse(cr, uid, ids, context={}):
                for line in order.order_line:
                    for move in line.move_ids:
                        self.pool.get('stock.move').write(cr, uid, move.id, {'product_second_uom_qty': line.product_second_uom_qty, 'product_second_uom': line.product_second_uom.id})
        return result
        
sale_order()
class sale_order_line(osv.osv):
    _inherit = "sale.order.line"
    _columns = {
              'product_second_uom_qty': fields.float('Quantity (Second UoM)', digits=(16, 2)),
              'product_second_uom': fields.many2one('product.uom', 'Product Second UoM'),
              'related_use_second_uom': fields.related('product_id', 'use_second_uom', type='boolean', string='Use Second UOM'),
              }
    _defaults = {
                'product_second_uom_qty': lambda *a: 1
                }
    
    def product_id_change(self, cr, uid, ids, pricelist, product, qty=0,
            uom=False, qty_uos=0, uos=False, name='', partner_id=False,
            lang=False, update_tax=True, date_order=False, packaging=False, fiscal_position=False, flag=False):
        
            result = super(sale_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty,
            uom, qty_uos, uos, name, partner_id,
            lang, update_tax, date_order, packaging, fiscal_position, flag)

            if product:
                product_obj = self.pool.get('product.product').browse(cr, uid, product)
                if product_obj.use_second_uom:
                    result['value'].update({'product_second_uom': product_obj.second_uom_id.id, 'related_use_second_uom': product_obj.use_second_uom})
                else:
                    result['value'].update({'product_second_uom_qty': False, 'product_second_uom': False, 'related_use_second_uom': False})
            else:
                result['value'].update({'product_second_uom_qty': False, 'product_second_uom': False, 'related_use_second_uom': False})
                
            return result
        
    def invoice_line_create(self, cr, uid, ids, context={}):
        
        result = super(sale_order_line, self).invoice_line_create(cr, uid, ids, context={})
        
        for line in self.browse(cr, uid, ids, context={}):
            for invoice in line.invoice_lines:
                self.pool.get('account.invoice.line').write(cr, uid, invoice.id, {'product_second_uom_qty': line.product_second_uom_qty, 'product_second_uom': line.product_second_uom.id})
                    
        return result

sale_order_line()
